#include <iostream>
using namespace std;

const int CODL = 8;
const int MAXS = 100;
const int MAXO = 50;
const int MAXV = 80;

struct Vino {
  char nome[MAXS];
  int anno;
  float quantita;
  float prezzo;
  char codice[CODL];
};

struct Magazzino {
  Vino vi[MAXV];
  int numVi;
};

struct Ordine {
  char codice[CODL];
  float quantita;
};

struct CodaOrd {
  Ordine ord[MAXO];
  int front;
  int back;
};

struct Cantina {
  Magazzino mag;
  CodaOrd coda;
};

void calcolaCodice(const char n[], int a, char cod[]); 

int caricaVino(Cantina* pc,  const char nf[]);

bool nuovoOrdine(Cantina* pc, Ordine o);

float evadi(Cantina* pc);

void stampa(const Cantina* pc);

void init(Cantina* pc) {
  pc->mag.numVi = 0;
  pc->coda.front = 0;
  pc->coda.back = 0;
}

void menu(){
  cout << "\n\n-------------------------" << endl;
  cout << "1) calcola codice" << endl; 
  cout << "2) carica vino" << endl; 
  cout << "3) nuovo ordine" << endl; 
  cout << "4) evadi" << endl; 
  cout << "5) stampa tutto" << endl; 
  cout << "6) esci" << endl; 
  cout << "Scelta? ";
}

Ordine leggiOrdine(){
  Ordine o;
  cout << "Inserisci codice ordine: ";
  cin >> o.codice;
  cout << "Inserisci quantita ordine: ";
  cin >> o.quantita;
  return o;
}

int main(){
  Cantina cant;
  init(&cant);

  char s;
  int anno;
  char codice[CODL];
  char nome[MAXS];
  bool result; 
  int q;
  Ordine ordine;
  float totale;

  while(true) {
    menu();
    cin >> s;
    switch(s){
      case '1':
        cout << "Inserisci nome: ";
        cin >> nome;
        cout << "Inserisci anno: ";
        cin >> anno;        
        calcolaCodice(nome, anno, codice);
        cout << "Codice: " << codice << endl;
        break;
      case '2':
        q = caricaVino(&cant, "input.txt");
        if(q>0) cout << "Ho caricato i dati di " << q << " vini" << endl;
        else cout << "Problema durante il caricamento" << endl;
        break;
      case '3':
        ordine = leggiOrdine();
        result = nuovoOrdine(&cant, ordine);
        if(result) cout << "Nuovo ordine inserito" << endl;
        else cout << "Ordine non inserito" << endl;
        break;
      case '4':
        totale = evadi(&cant);
        cout << "Il totale degli ordini evasi ammonta a " << totale << endl;
        break;
      case '5':
        stampa(&cant);
        break;
      case '6':
        return 0;
    }
  }
}
